import type { RouteLocationNormalizedLoaded } from 'vue-router';
import type { DefineComponent, Ref, ComputedRef, ComponentOptionsMixin, VNodeProps, AllowedComponentProps, ComponentCustomProps, ExtractPropTypes, ref } from 'vue';
declare const _sfc_main: DefineComponent<{
    url: {
        type: StringConstructor;
        required: true;
    };
    source: {
        type: null;
        required: true;
    };
    rowKey: {
        type: StringConstructor;
        required: false;
    };
    rowKeys: {
        type: ArrayConstructor;
        required: false;
    };
    keyName: {
        type: StringConstructor;
        required: false;
    };
    queryAfterMount: {
        type: BooleanConstructor;
        required: false;
        default: boolean;
    };
    openMultipleSelection: {
        type: BooleanConstructor;
        required: false;
    };
    expand: {
        type: BooleanConstructor;
        required: false;
    };
    PaginationLayout: {
        type: StringConstructor;
        required: false;
        default: string;
    };
    fullscreen: {
        type: BooleanConstructor;
        required: false;
    };
    modalWidth: {
        type: StringConstructor;
        required: false;
        default: string;
    };
    closeOnPressEscape: {
        type: BooleanConstructor;
        required: false;
    };
    editFooterButton: {
        type: BooleanConstructor;
        required: false;
        default: boolean;
    };
    AddInitID: {
        type: ArrayConstructor;
        required: false;
    };
    watchData: {
        type: null;
        required: false;
    };
    hooks: {
        type: null;
        required: false;
    };
    wrapperStyle: {
        type: ObjectConstructor;
        required: false;
    };
}, {
    props: {
        url: string;
        source: SourceOptType;
        rowKey?: string | undefined;
        rowKeys?: string[] | undefined;
        keyName?: string | undefined;
        queryAfterMount: boolean;
        openMultipleSelection?: boolean | undefined;
        expand?: boolean | undefined;
        PaginationLayout: string;
        fullscreen?: boolean | undefined;
        modalWidth: string;
        closeOnPressEscape?: boolean | undefined;
        editFooterButton: boolean;
        AddInitID?: string[] | undefined;
        watchData?: watchDataType | undefined;
        hooks?: HooksObjectType | undefined;
        wrapperStyle?: object | undefined;
    };
    emit: (event: "update:modelValue" | "cell-click" | "row-contextmenu", ...args: any[]) => void;
    route: RouteLocationNormalizedLoaded;
    crudOptions: SystemParametersType;
    hookHandler: (hookName: string, data: {
        CrudState: any;
        Data: any;
    }) => boolean;
    CRUDRequest: any;
    ElementArrs: Ref<{
        filter: {
            [x: string]: columnsType;
        };
        editor: {
            [x: string]: columnsType;
        };
        column: {
            [x: string]: columnsType;
        };
    }>;
    tableColumn: Ref<any>;
    tableRef: Ref<any>;
    tableData: Ref<any>;
    originalData: Ref<any>;
    initSearchModel: Ref<any>;
    initEditModel: Ref<any>;
    searchModel: any;
    searchFormValue: any;
    editModel: any;
    editFormValue: any;
    multipleSelection: Ref<never[]>;
    uploadFiles: Ref<any>;
    tableLoading: Ref<boolean>;
    FormRef: Ref<any>;
    Mode: Ref<string>;
    DialogVisible: Ref<boolean>;
    submitLoading: Ref<boolean>;
    DialogVisibleFooterButton: typeof ref;
    Pagination: Ref<{
        current: number;
        pageSize: number;
        total: number;
    }>;
    queryRecord: () => void;
    responseData: (Data: any, reqDataSource: any) => void;
    refresh: () => void;
    addRecord: () => void;
    editRecord: (row: any) => void;
    handleSubmit: (formEl: any) => Promise<void>;
    handleAdd: (value: any) => void;
    handleEdit: (value: any) => void;
    delFlag: (row: any) => void;
    deleteRecord: (row: any) => void;
    deleteMulRecord: () => void;
    cellClick: (row: any, column: any, cell: any, event: any) => void;
    rowContextmenu: (row: any, column: any, event: any) => void;
    handleSelectionChange: (value: any) => void;
    formComponentProps: (item: any) => any;
    tableComponentProps: (item: any, scope: any) => any;
    componentVisible: (visible: boolean | Function) => boolean | Function;
    handleSizeChange: (value: number) => void;
    handleCurrentChange: (value: number) => void;
    expandComputed: (props: any, item: any) => any;
    WrapperStyle: ComputedRef<{}>;
    watchGetData: (row: {
        url: any;
        name: any;
        data: any;
        label: string | number | (string | number)[];
        value: string | number;
        key: any;
    }) => void;
    CrudState: {
        ElementArrs: {
            filter: {
                [x: string]: columnsType;
            };
            editor: {
                [x: string]: columnsType;
            };
            column: {
                [x: string]: columnsType;
            };
        };
        searchModel: any;
        searchFormValue: any;
        editModel: any;
        editFormValue: any;
        uploadFiles: any;
        tableLoading: boolean;
        Pagination: {
            current: number;
            pageSize: number;
            total: number;
        };
        Mode: string;
        queryRecord: () => void;
    };
}, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, ("update:modelValue" | "cell-click" | "row-contextmenu")[], "update:modelValue" | "cell-click" | "row-contextmenu", VNodeProps & AllowedComponentProps & ComponentCustomProps, Readonly<ExtractPropTypes<{
    url: {
        type: StringConstructor;
        required: true;
    };
    source: {
        type: null;
        required: true;
    };
    rowKey: {
        type: StringConstructor;
        required: false;
    };
    rowKeys: {
        type: ArrayConstructor;
        required: false;
    };
    keyName: {
        type: StringConstructor;
        required: false;
    };
    queryAfterMount: {
        type: BooleanConstructor;
        required: false;
        default: boolean;
    };
    openMultipleSelection: {
        type: BooleanConstructor;
        required: false;
    };
    expand: {
        type: BooleanConstructor;
        required: false;
    };
    PaginationLayout: {
        type: StringConstructor;
        required: false;
        default: string;
    };
    fullscreen: {
        type: BooleanConstructor;
        required: false;
    };
    modalWidth: {
        type: StringConstructor;
        required: false;
        default: string;
    };
    closeOnPressEscape: {
        type: BooleanConstructor;
        required: false;
    };
    editFooterButton: {
        type: BooleanConstructor;
        required: false;
        default: boolean;
    };
    AddInitID: {
        type: ArrayConstructor;
        required: false;
    };
    watchData: {
        type: null;
        required: false;
    };
    hooks: {
        type: null;
        required: false;
    };
    wrapperStyle: {
        type: ObjectConstructor;
        required: false;
    };
}>> & {
    "onUpdate:modelValue"?: ((...args: any[]) => any) | undefined;
    "onCell-click"?: ((...args: any[]) => any) | undefined;
    "onRow-contextmenu"?: ((...args: any[]) => any) | undefined;
}, {
    queryAfterMount: boolean;
    openMultipleSelection: boolean;
    expand: boolean;
    PaginationLayout: string;
    fullscreen: boolean;
    modalWidth: string;
    closeOnPressEscape: boolean;
    editFooterButton: boolean;
}>;
export default _sfc_main;
